From cfa2cef4ee61ceb4dc080c51db313de26c6fef05 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jan 28 2017 09:04:21 +0000
Subject: [PATCH 678/1001] Fix string/unicode compat issues with Python 3


---

diff --git a/check-cache-coverage.py b/check-cache-coverage.py
index 0f6c6f7..a753f56 100755
--- a/check-cache-coverage.py
+++ b/check-cache-coverage.py
@@ -13,6 +13,8 @@ forcibly re-warms the cache.
 Authors:    Ralph Bean <rbean@redhat.com>
 """
 
+from __future__ import unicode_literals
+
 import sys
 import dogpile.cache
 
diff --git a/check-queue-length.py b/check-queue-length.py
index 4fc7098..5b14d0f 100755
--- a/check-queue-length.py
+++ b/check-queue-length.py
@@ -13,6 +13,8 @@ We could also graph this in collectd, for fun and profit.
 Authors:    Ralph Bean <rbean@redhat.com>
 """
 
+from __future__ import unicode_literals
+
 import fedmsg.config
 config = fedmsg.config.load_config()
 
diff --git a/delete-user.py b/delete-user.py
index acc2563..42a17c1 100755
--- a/delete-user.py
+++ b/delete-user.py
@@ -4,6 +4,8 @@
 Useful for testing what happens when you recreate them.
 """
 
+from __future__ import unicode_literals
+
 import sys
 
 import fedmsg.config
diff --git a/hubs/app.py b/hubs/app.py
index f75b404..ca3bd26 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -1,4 +1,4 @@
-from __future__ import print_function
+from __future__ import print_function, unicode_literals
 
 import datetime
 import functools
@@ -455,7 +455,7 @@ def widget_source(name):
     fname = ''
 
     try:
-        fname = base + registry[name].__file__.split(base, 1)[1]
+        fname = base + registry[name].__file__.split(base)[-1]
     except KeyError:
         flask.abort(404)
 
diff --git a/hubs/backend/consumer.py b/hubs/backend/consumer.py
index 9d73ef1..7ea5083 100755
--- a/hubs/backend/consumer.py
+++ b/hubs/backend/consumer.py
@@ -1,5 +1,7 @@
 # The fedora hubs backend daemon
 
+from __future__ import unicode_literals
+
 import fedmsg.consumers
 import fedmsg.meta
 
diff --git a/hubs/backend/triage.py b/hubs/backend/triage.py
index ad86221..c1bf1da 100755
--- a/hubs/backend/triage.py
+++ b/hubs/backend/triage.py
@@ -19,6 +19,8 @@ though.  If they see that invalidation is required, they put a new task on an
 handle.
 """
 
+from __future__ import unicode_literals
+
 import hubs.app
 import hubs.models
 
diff --git a/hubs/backend/worker.py b/hubs/backend/worker.py
index 11c3342..abc1b32 100755
--- a/hubs/backend/worker.py
+++ b/hubs/backend/worker.py
@@ -24,6 +24,8 @@ another redis queue so that an EventSource server can update any connected web
 clients with the new content produced here.
 """
 
+from __future__ import unicode_literals
+
 import hubs.app
 import hubs.models
 
diff --git a/hubs/default_config.py b/hubs/default_config.py
index bb9ef80..769f8ad 100755
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import os
 
 SECRET_KEY = 'changemeforreal'
diff --git a/hubs/defaults.py b/hubs/defaults.py
index 2a27612..d91d452 100755
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 import hubs.models
diff --git a/hubs/hinting.py b/hubs/hinting.py
index 14ed445..b1a8c2f 100755
--- a/hubs/hinting.py
+++ b/hubs/hinting.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import decorator
 
 import fedmsg.config
diff --git a/hubs/models.py b/hubs/models.py
index add289e..cdc02de 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -20,6 +20,7 @@
 # of Red Hat, Inc.
 #
 
+from __future__ import unicode_literals
 
 import datetime
 import json
diff --git a/hubs/stream.py b/hubs/stream.py
index fd45923..ced01b9 100644
--- a/hubs/stream.py
+++ b/hubs/stream.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 import os
 
diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index e7f4eba..3730d4e 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from contextlib import contextmanager
 import json
 from datetime import datetime, timedelta
diff --git a/hubs/tests/test_api/test_hub.py b/hubs/tests/test_api/test_hub.py
index 815411d..821746c 100644
--- a/hubs/tests/test_api/test_hub.py
+++ b/hubs/tests/test_api/test_hub.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import flask
 import unittest
 from six.moves.urllib.parse import urlparse
diff --git a/hubs/tests/test_api/test_notifications.py b/hubs/tests/test_api/test_notifications.py
index 66f8d99..360fa4c 100644
--- a/hubs/tests/test_api/test_notifications.py
+++ b/hubs/tests/test_api/test_notifications.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 from six.moves.urllib.parse import urlparse
 
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index d94ef4a..edfc6a6 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import unittest
 from six.moves.urllib.parse import urlparse
 import ast # import for string to dict conversion without unicode
@@ -34,16 +36,16 @@ class HubsAPITest(hubs.tests.APPTest):
             # assert the status code of the response
             self.assertEqual(result.status_code, 200)
             self.assertFalse('Not logged in.  Click to <a href="'
-                             '/login">login</a>' in result.data)
+                             '/login">login</a>' in to_str(result.data))
 
     def test_hub_logged_out(self):
         with tests.auth_set(app, None):  # check_auth doesn't load in unittest
             result = self.app.get('/ralph', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
             match_expected = r'<h5[^>]*>Ralph</h5>'
-            self.assertRegexpMatches(result.data, match_expected)
+            self.assertRegexpMatches(to_str(result.data), match_expected)
             str_expected = 'Not logged in.'
-            self.assertTrue(str_expected in result.data)
+            self.assertTrue(str_expected in to_str(result.data))
 
     def test_groups_logged_out(self):
         result = self.app.get('/groups', follow_redirects=False)
@@ -58,7 +60,8 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.get('/groups', follow_redirects=True)
             # assert the status code of the response
             self.assertEqual(result.status_code, 200)
-            self.assertTrue("ZOMG -  is the Hub Of The Month!" in result.data)
+            self.assertTrue("ZOMG -  is the Hub Of The Month!"
+                            in to_str(result.data))
 
     def test_hub_logged_in(self):
         user = tests.FakeAuthorization('ralph')
@@ -66,7 +69,7 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.get('/ralph', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
             self.assertFalse('Not logged in.  Click to <a href="'
-                             '/login">login</a>' in result.data)
+                             '/login">login</a>' in to_str(result.data))
 
     def test_hub_json(self):
         result = self.app.get('/ralph/json', follow_redirects=True)
@@ -84,7 +87,7 @@ class HubsAPITest(hubs.tests.APPTest):
             "summary": "Ralph",
             "widgets": [34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 56]
         }
-        self.assertDictEqual(data, ast.literal_eval(result.data))
+        self.assertDictEqual(data, json.loads(to_str(result.data)))
 
     @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_get_logged_out(self):
@@ -134,9 +137,9 @@ class HubsAPITest(hubs.tests.APPTest):
                                    follow_redirects=True)
             self.assertEqual(result.status_code, 200)
             self.assertFalse('Not logged in.  Click to <a href="'
-                             '/login">login</a>' in result.data)
+                             '/login">login</a>' in to_str(result.data))
             self.assertTrue('<a href="#" class="dropdown-item">Full Name: '
-                            'fullname: ralph</a>' in result.data)
+                            'fullname: ralph</a>' in to_str(result.data))
 
     def test_hub_edit_post_logged_in_owner_valid_data(self):
         user = tests.FakeAuthorization('ralph')
@@ -157,7 +160,7 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.post('/ralph/edit', data=data,
                                    follow_redirects=True)
             self.assertEqual(result.status_code, 200)
-            self.assertEqual(result.data, 'ok')
+            self.assertEqual(to_str(result.data), 'ok')
 
     def test_hub_edit_post_logged_in_owner_invalid_data_1(self):
         user = tests.FakeAuthorization('ralph')
@@ -212,30 +215,30 @@ class HubsAPITest(hubs.tests.APPTest):
         result = self.app.get('/ralph/add', follow_redirects=False)
         self.assertEqual(result.status_code, 400)
         expected_str = 'Invalid position provided'
-        self.assertTrue(expected_str in result.data)
+        self.assertTrue(expected_str in to_str(result.data))
 
     def test_hub_add_widget_get_with_args(self):
         result = self.app.get('/ralph/add?position=right',
                               follow_redirects=True)
         self.assertEqual(result.status_code, 200)
         expected_str = 'Adding widget to hub: ralph'
-        self.assertTrue(expected_str in result.data)
+        self.assertTrue(expected_str in to_str(result.data))
         expected_str = "url: 'add/' + $('#widget').val() + '?position=right',"
-        self.assertTrue(expected_str in result.data)
+        self.assertTrue(expected_str in to_str(result.data))
 
     def test_hub_add_widget_post_no_widget_name(self):
         data = {}
         result = self.app.post('/ralph/add', data=data, follow_redirects=False)
         self.assertEqual(result.status_code, 400)
         expected_str = 'Invalid request sent'
-        self.assertTrue(expected_str in result.data)
+        self.assertTrue(expected_str in to_str(result.data))
 
     def test_hub_add_widget_post_invalid_widget_name(self):
         data = {'widget_name': 'invalid_widget_name'}
         result = self.app.post('/ralph/add', data=data, follow_redirects=False)
         self.assertEqual(result.status_code, 404)
         expected_str = 'Unknown widget called'
-        self.assertTrue(expected_str in result.data)
+        self.assertTrue(expected_str in to_str(result.data))
 
     def test_hub_add_widget_post_valid_widget_name_no_args(self):
         user = tests.FakeAuthorization('ralph')
@@ -245,9 +248,9 @@ class HubsAPITest(hubs.tests.APPTest):
                                    follow_redirects=False)
             self.assertEqual(result.status_code, 200)
             expected_str = '<h6 class="dropdown-header">Account Information</h6>'
-            self.assertTrue(expected_str in result.data)
+            self.assertTrue(expected_str in to_str(result.data))
             expected_str = '<a href="#" class="dropdown-item">Full Name: fullname: ralph</a>'
-            self.assertTrue(expected_str in result.data)
+            self.assertTrue(expected_str in to_str(result.data))
 
     def test_hub_add_widget_post_valid_widget_name_with_args(self):
         user = tests.FakeAuthorization('ralph')
@@ -257,9 +260,9 @@ class HubsAPITest(hubs.tests.APPTest):
                                    follow_redirects=False)
             self.assertEqual(result.status_code, 200)
             expected_str = '<h6 class="dropdown-header">Account Information</h6>'
-            self.assertTrue(expected_str in result.data)
+            self.assertTrue(expected_str in to_str(result.data))
             expected_str = '<a href="#" class="dropdown-item">Full Name: fullname: ralph</a>'
-            self.assertTrue(expected_str in result.data)
+            self.assertTrue(expected_str in to_str(result.data))
 
     def test_hub_edit_widget_get_logged_in(self):
         user = tests.FakeAuthorization('ralph')
@@ -267,7 +270,7 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.get('/ralph/37/edit', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
             expected_str = '/ralph/37/edit'
-            self.assertTrue(expected_str in result.data)
+            self.assertTrue(expected_str in to_str(result.data))
 
     @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_widget_get_logged_out(self):
@@ -314,21 +317,22 @@ class HubsAPITest(hubs.tests.APPTest):
         with tests.auth_set(app, user):
             url = '/visit/decause'
             result = self.app.get(url)
-            self.assertEqual(result.data, '0')
+            self.assertEqual(to_str(result.data), '0')
 
             url = '/decause'
             result = self.app.get(url, follow_redirects=True)
 
             url = '/visit/decause'
             result = self.app.get(url)
-            self.assertEqual(result.data, '1')
+            self.assertEqual(to_str(result.data), '1')
 
     def test_hub_add_widget_valid_side(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
             url = '/ralph/add/about?position=right'
             result = self.app.get(url)
-            self.assertTrue('Adding widget "about"to hub: ralph' in result.data)
+            self.assertTrue('Adding widget "about"to hub: ralph'
+                            in to_str(result.data))
 
     def test_hub_add_widget_invalid_side(self):
         user = tests.FakeAuthorization('ralph')
@@ -343,7 +347,7 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/ralph/37/delete'  # 37 is widget fedmsgstats for ralph
             result = self.app.post(url)
             self.assertEqual(result.status_code, 302)
-            self.assertTrue('/ralph/edit' in result.data)
+            self.assertTrue('/ralph/edit' in to_str(result.data))
 
     def test_source_name(self):
         with tests.auth_set(app, None):
@@ -352,7 +356,7 @@ class HubsAPITest(hubs.tests.APPTest):
             self.assertEqual(result.status_code, 302)
             expected_str = 'https://pagure.io/fedora-hubs/' \
                            'blob/develop/f/hubs/widgets/about.py'
-            self.assertTrue(expected_str in result.data)
+            self.assertIn(expected_str, to_str(result.data))
 
     def test_source_name_not_existent(self):
         with tests.auth_set(app, None):
@@ -416,7 +420,7 @@ class HubsAPITest(hubs.tests.APPTest):
             "total": 0,
             "username": "decause"
         }
-        self.assertEqual(load_json(result.data), expected)
+        self.assertEqual(json.loads(to_str(result.data)), expected)
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_valid(self, mock_post):
@@ -432,7 +436,7 @@ class HubsAPITest(hubs.tests.APPTest):
                 "total": 1,
                 "username": "decause"
             }
-            self.assertEqual(load_json(result.data), expected)
+            self.assertEqual(json.loads(to_str(result.data)), expected)
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_myself_error(self, mock_post):
@@ -441,7 +445,7 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/plus_plus/ralph/update'
             result = self.app.post(url, data={'increment': True})
             self.assertEqual(result.status_code, 403)
-            self.assertEqual(result.data, 'You may not modify your own karma.')
+            self.assertEqual(to_str(result.data), 'You may not modify your own karma.')
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_user_does_not_exist(self, mock_post):
@@ -450,7 +454,7 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/plus_plus/doesnotexist/update'
             result = self.app.post(url, data={'increment': True})
             self.assertEqual(result.status_code, 403)
-            self.assertEqual(result.data, 'User does not exist')
+            self.assertEqual(to_str(result.data), 'User does not exist')
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_no_data_error(self, mock_post):
@@ -461,13 +465,13 @@ class HubsAPITest(hubs.tests.APPTest):
             self.assertEqual(result.status_code, 403)
             exp_str = "You must set 'decrement' or 'increment' " \
                       "with a boolean value in the body"
-            self.assertEqual(result.data, exp_str)
+            self.assertEqual(to_str(result.data), exp_str)
 
     def test_plus_plus_receiver_does_not_exist(self):
         url = '/plus_plus/doesnotexist/status'
         result = self.app.get(url)
         self.assertEqual(result.status_code, 403)
-        self.assertEqual(result.data, 'User does not exist')
+        self.assertEqual(to_str(result.data), 'User does not exist')
 
 
 
diff --git a/hubs/tests/test_models.py b/hubs/tests/test_models.py
index 93f4a31..3065cfb 100644
--- a/hubs/tests/test_models.py
+++ b/hubs/tests/test_models.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import hubs
 import hubs.models
 import hubs.tests
diff --git a/hubs/tests/test_widgets/__init__.py b/hubs/tests/test_widgets/__init__.py
index 9b9ac69..47a2f4f 100644
--- a/hubs/tests/test_widgets/__init__.py
+++ b/hubs/tests/test_widgets/__init__.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 from datetime import datetime, timedelta
 from os.path import dirname
diff --git a/hubs/tests/test_widgets/test_about.py b/hubs/tests/test_widgets/test_about.py
index 2e358d0..f894e4b 100644
--- a/hubs/tests/test_widgets/test_about.py
+++ b/hubs/tests/test_widgets/test_about.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 from nose.tools import assert_dict_equal
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index b7831c0..2dd6458 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 from mock import patch, MagicMock
diff --git a/hubs/tests/test_widgets/test_fedmsgstats.py b/hubs/tests/test_widgets/test_fedmsgstats.py
index 5f16417..bec2363 100644
--- a/hubs/tests/test_widgets/test_fedmsgstats.py
+++ b/hubs/tests/test_widgets/test_fedmsgstats.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 import hubs.tests.test_widgets
diff --git a/hubs/tests/test_widgets/test_library.py b/hubs/tests/test_widgets/test_library.py
index 58376c4..68f2598 100644
--- a/hubs/tests/test_widgets/test_library.py
+++ b/hubs/tests/test_widgets/test_library.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 import hubs.tests.test_widgets
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 5df4bd5..d3b3f09 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 import hubs.tests.test_widgets
@@ -21,5 +23,6 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance(team, self.plugin)
         response = self.app.get('/%s/%i/' % (team, widget.idx))
         self.assertEqual(200, response.status_code)
-        self.assertIn('i18n', response.data)
-        self.assertIn('<strong>Request A New Meeting</strong>', response.data)
+        self.assertIn('i18n', to_str(response.data))
+        self.assertIn('<strong>Request A New Meeting</strong>',
+                      to_str(response.data))
diff --git a/hubs/utils.py b/hubs/utils.py
index f5166bd..c858271 100755
--- a/hubs/utils.py
+++ b/hubs/utils.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 import logging
 from hashlib import sha256
@@ -20,10 +22,7 @@ def markup(text):
 
 
 def username2avatar(username, s=312):
-    query = urlencode({
-        'd': 'retro',
-        's': s,
-    })
+    query = urlencode([('s', s), ('d', 'retro')])
     openid = 'http://%s.id.fedoraproject.org/' % username
     hash = sha256(openid.encode('utf-8')).hexdigest()
     avatar = "https://seccdn.libravatar.org/avatar/%s?%s" % (hash, query)
diff --git a/hubs/validators.py b/hubs/validators.py
index 2ae918f..302b0e7 100755
--- a/hubs/validators.py
+++ b/hubs/validators.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import kitchen.text.converters
 
 import hubs.models
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 5f416ed..95253e7 100755
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.widgets import dummy
 from hubs.widgets import stats
 from hubs.widgets import rules
diff --git a/hubs/widgets/about.py b/hubs/widgets/about.py
index 4be594c..7f0d994 100755
--- a/hubs/widgets/about.py
+++ b/hubs/widgets/about.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
diff --git a/hubs/widgets/badges.py b/hubs/widgets/badges.py
index abf4b15..86bc929 100755
--- a/hubs/widgets/badges.py
+++ b/hubs/widgets/badges.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import operator
 
 import requests
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index f3cf198..581532e 100755
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import collections
 import datetime
 import functools
diff --git a/hubs/widgets/bugzilla.py b/hubs/widgets/bugzilla.py
index a33e318..c2d94ae 100644
--- a/hubs/widgets/bugzilla.py
+++ b/hubs/widgets/bugzilla.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import requests
 import pkgwat.api
 
diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
index 717e047..b869094 100755
--- a/hubs/widgets/chrome.py
+++ b/hubs/widgets/chrome.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.widgets.base import wraps
 from hubs.widgets import templating
 
diff --git a/hubs/widgets/clean_input.py b/hubs/widgets/clean_input.py
index 2ec458a..9d25104 100644
--- a/hubs/widgets/clean_input.py
+++ b/hubs/widgets/clean_input.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from six.moves.urllib.parse import urlparse
 
 import bleach
diff --git a/hubs/widgets/contact.py b/hubs/widgets/contact.py
index b76873c..b14e126 100644
--- a/hubs/widgets/contact.py
+++ b/hubs/widgets/contact.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import flask
 
 import fedmsg.config
diff --git a/hubs/widgets/dummy.py b/hubs/widgets/dummy.py
index 2e73bca..bd198d3 100755
--- a/hubs/widgets/dummy.py
+++ b/hubs/widgets/dummy.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
diff --git a/hubs/widgets/fedmsgstats.py b/hubs/widgets/fedmsgstats.py
index 533c563..0cf5ba2 100755
--- a/hubs/widgets/fedmsgstats.py
+++ b/hubs/widgets/fedmsgstats.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint
 from hubs.widgets.chrome import panel
 from hubs.widgets import templating
diff --git a/hubs/widgets/feed.py b/hubs/widgets/feed.py
index 8ea6536..5d744d9 100755
--- a/hubs/widgets/feed.py
+++ b/hubs/widgets/feed.py
@@ -1,4 +1,4 @@
-from __future__ import print_function
+from __future__ import print_function, unicode_literals
 
 from hubs.hinting import hint
 from hubs.widgets.base import argument
diff --git a/hubs/widgets/fhosted.py b/hubs/widgets/fhosted.py
index 827b228..bc97d8b 100644
--- a/hubs/widgets/fhosted.py
+++ b/hubs/widgets/fhosted.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from six.moves.xmlrpc_client import ServerProxy
 
 import hubs.validators as validators
diff --git a/hubs/widgets/github_pr.py b/hubs/widgets/github_pr.py
index b2d1788..c2a0be9 100755
--- a/hubs/widgets/github_pr.py
+++ b/hubs/widgets/github_pr.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import logging
 
 from hubs.widgets.chrome import panel
diff --git a/hubs/widgets/githubissues.py b/hubs/widgets/githubissues.py
index 986ff11..7130183 100755
--- a/hubs/widgets/githubissues.py
+++ b/hubs/widgets/githubissues.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import requests
 
 from hubs.hinting import hint
diff --git a/hubs/widgets/library.py b/hubs/widgets/library.py
index b18354a..08ad334 100644
--- a/hubs/widgets/library.py
+++ b/hubs/widgets/library.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
@@ -21,9 +23,9 @@ def data(session, widget, urls):
 
     urls = [
         clean_input.clean(
-            '<a href="{0}">{0}</a>'.format(u.encode('utf-8').strip()))
+            '<a href="{0}">{0}</a>'.format(u.strip()))
         for u in widget.config.get('urls', '').split(',')
-        if u.encode('utf-8').strip()
+        if u.strip()
     ]
     return dict(urls=urls)
 
diff --git a/hubs/widgets/linechart.py b/hubs/widgets/linechart.py
index f12ef8f..3d41057 100755
--- a/hubs/widgets/linechart.py
+++ b/hubs/widgets/linechart.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint
 from hubs.widgets.base import argument
 from hubs.widgets import templating
diff --git a/hubs/widgets/meetings.py b/hubs/widgets/meetings.py
index 8c05744..713177b 100755
--- a/hubs/widgets/meetings.py
+++ b/hubs/widgets/meetings.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint
 from hubs.widgets.base import argument
 from hubs.widgets.chrome import panel
diff --git a/hubs/widgets/memberships.py b/hubs/widgets/memberships.py
index 48d8fea..2763db0 100644
--- a/hubs/widgets/memberships.py
+++ b/hubs/widgets/memberships.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import hubs.models
 from hubs.hinting import hint, prefixed as _
 import hubs.validators as validators
diff --git a/hubs/widgets/pagure_pr.py b/hubs/widgets/pagure_pr.py
index cdb8365..081dcb4 100755
--- a/hubs/widgets/pagure_pr.py
+++ b/hubs/widgets/pagure_pr.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
diff --git a/hubs/widgets/pagureissues.py b/hubs/widgets/pagureissues.py
index c9ecd53..9a4dca8 100755
--- a/hubs/widgets/pagureissues.py
+++ b/hubs/widgets/pagureissues.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import requests
 
 from hubs.hinting import hint
diff --git a/hubs/widgets/rules.py b/hubs/widgets/rules.py
index 443f07c..d7554b9 100755
--- a/hubs/widgets/rules.py
+++ b/hubs/widgets/rules.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from collections import OrderedDict as ordereddict
 
 from hubs.hinting import hint, prefixed as _
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index 55c90db..ebd6cc8 100755
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets import templating
diff --git a/hubs/widgets/sticky.py b/hubs/widgets/sticky.py
index 55cc6a1..ca74f59 100755
--- a/hubs/widgets/sticky.py
+++ b/hubs/widgets/sticky.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
diff --git a/hubs/widgets/subscriptions.py b/hubs/widgets/subscriptions.py
index 82fce66..8035d3d 100755
--- a/hubs/widgets/subscriptions.py
+++ b/hubs/widgets/subscriptions.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.base import argument
 from hubs.widgets.chrome import panel
diff --git a/hubs/widgets/templating.py b/hubs/widgets/templating.py
index 98b29cd..41e0c5b 100644
--- a/hubs/widgets/templating.py
+++ b/hubs/widgets/templating.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import os
 
 import jinja2
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 581bd70..5bc6594 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import requests
 
 from hubs.hinting import hint, prefixed as _
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index 675d793..c7df1c3 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import requests
 
 from hubs.hinting import hint, prefixed as _
diff --git a/populate-from-fas.py b/populate-from-fas.py
index 7639c81..b74e8a6 100755
--- a/populate-from-fas.py
+++ b/populate-from-fas.py
@@ -1,6 +1,8 @@
 #!/usr/bin/env python
 """ Populate the hubs db with lots of data from FAS. """
 
+from __future__ import unicode_literals
+
 import getpass
 import socket
 import string
diff --git a/populate.py b/populate.py
index 5c34700..4286940 100755
--- a/populate.py
+++ b/populate.py
@@ -1,6 +1,8 @@
 #!/usr/bin/env python
 """ Populate the hubs db with some dev data. """
 
+from __future__ import unicode_literals
+
 import json
 
 import hubs.models
diff --git a/runserver.py b/runserver.py
index 5e5a4f2..9552b0a 100755
--- a/runserver.py
+++ b/runserver.py
@@ -1,5 +1,7 @@
 #!/usr/bin/env python2
 
+from __future__ import unicode_literals
+
 import argparse
 import sys
 import os
diff --git a/setup.py b/setup.py
index 15f69c2..aa9b63e 100644
--- a/setup.py
+++ b/setup.py
@@ -1,5 +1,7 @@
 """ Setup file for fedora hubs """
 
+from __future__ import unicode_literals
+
 from setuptools import setup, find_packages
 
 
diff --git a/smart_cache_invalidator.py b/smart_cache_invalidator.py
index 77021fc..25c2540 100755
--- a/smart_cache_invalidator.py
+++ b/smart_cache_invalidator.py
@@ -8,7 +8,7 @@ This is really useful for development purposes as it allow seeing changes
 made to a widget without dropping the entire cache database.
 """
 
-from __future__ import print_function
+from __future__ import print_function, unicode_literals
 
 import argparse
 import os

